package com.yeory.gv;

import java.io.IOException;
import java.util.ArrayList;

import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;

import android.app.Activity;
import android.app.ProgressDialog;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.KeyEvent;
import android.widget.AbsListView;
import android.widget.AbsListView.OnScrollListener;
import android.widget.GridView;
import android.widget.TextView;
import android.widget.Toast;

import com.yeory.gv.common.CommonResources;
import com.yeory.gv.model.Image;
import com.yeory.gv.util.CommonUtil;
import com.yeory.gv.util.ImageAdapter;
import com.yeory.gv.util.ImageDownloader;

/**
 * =============================================================================
/            Ʈ :   GridView_Example
/            ȭ     :   ImageList.java
/                   :   
/                   :   
/            Ư   :
/-----------------------------------------------------------------------------
/                                				                     
/-----------------------------------------------------------------------------
/           	(ۼ)                 		                  
/   ----------     	--------------------------       -------------------------
/   2010. 11. 10.      翭<jyeory@gmail.com>         		                         
/==============================================================================
 */
public class ImageList extends Activity {
	private final ImageDownloader imageDownloader = ImageDownloader.getInstance();
	
	private GridView gridView;
	private TextView textView;
	private ImageAdapter adapter;
	
	private boolean isNextPage = true;
	boolean needCached = true;
	final int size = 15;			// ѹ  ̹ 
	private int totalSize = 0;		// paging ʿ
	private int currentPage = 0;	// paging ʿ
	private int start = 0;			
	private int end = 0;
	private int endPage = 0;
	private int lastPosition = 0;
	private int firstPosition = 0;
	
	private ProgressDialog pd;
	private Thread thread;
	
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		if(keyCode == 4) CommonUtil.getInstance().requestKillProcess(this);
		return super.onKeyDown(keyCode, event);
	}
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        CommonResources.COMMON_CONTEXT = this;
        
        init(1, size);
        
        textView = (TextView) findViewById(R.id.logText);
        
        gridView = (GridView) findViewById(R.id.gridView);
        adapter = new ImageAdapter(this, imageList);
        
        gridView.setOnScrollListener(new OnScrollListener() {
			@Override
			public void onScrollStateChanged(AbsListView view, int scrollState) {
				isNextPage = imageList.size() < totalSize;
				try{
					switch (scrollState) {
					case 1:
						lastPosition = view.getLastVisiblePosition();
						firstPosition = view.getFirstVisiblePosition();
						if( lastPosition == (imageList.size()-1) && isNextPage ){
							pd = ProgressDialog.show(ImageList.this,  null, "  Դϴ.\nø ٷ ּ...", false, true);
							
							thread = new Thread(new Runnable() {
								public void run() {
									start = (++currentPage - 1) * size;
									if(start < totalSize){
										endPage = ((currentPage*size) < totalSize)?(currentPage*size):totalSize;
										imageList.addAll(wholeImageList.subList(start, endPage));
									}
//									downloadImages(imageList);
									handler.sendEmptyMessage(0);
								}
							});
							thread.start();
						}
						break;
					default:
						break;
					}
				}catch(Exception e){
					Log.i("error", "gridView.setOnScrollListener : "+e.getCause().toString());
				}
			}
			
//			firstVisibleItem : ȭ ֻ ̹ IDX
//			visibleItemCount :  ȭ鿡  ̹ 
			@Override
			public void onScroll(AbsListView view, int firstVisibleItem, int visibleItemCount, int totalItemCount) {
				textView.setText("onScroll : "+"view.getLastVisiblePosition() - "+view.getLastVisiblePosition()+" / "+totalItemCount);
			}
		});
        
        gridView.setAdapter(adapter);
        
        Toast.makeText(this, "Yeory - www.yeroy.com", Toast.LENGTH_LONG).show();
    }
    
    /**
	 * Image ٿεϰ ϰԲ ش ޼ ȣ. 
	 * @param images
	 */
	private void downloadImages(ArrayList<Image> images){
		// ̸ ٿް ȣ.
		for(Image image : images){
			imageDownloader.callDownloadImage(image.getThumbNail());
		}
	}
	
	private Handler handler= new Handler() {
		public void handleMessage(Message msg) {
			if(adapter == null) adapter = new ImageAdapter(ImageList.this, imageList);
			else{
				adapter.setList(imageList);
			}
			gridView.setAdapter(adapter);
			
			gridView.setSelection(firstPosition);
			pd.dismiss();
		}
	};
    
    private ArrayList<Image> wholeImageList = new ArrayList<Image>();	// ü ̹  .
	private ArrayList<Image> imageList = new ArrayList<Image>();	// κ ̹  .
	private XmlPullParser xpp;
	
    /**
	 * XML о鿩 ü ̹ ArrayList ִ´.
	 * ó ȣ Ǳ⿡ 15 ٸ list  ĳ. 
	 * @param page
	 * @param size
	 */
	private void init(final int page, final int size) {
		xpp = getResources().getXml(R.xml.url);
		try{
			while ( xpp.getEventType() != XmlPullParser.END_DOCUMENT ){  //  
				if ( xpp.getEventType() == XmlPullParser.START_TAG ){
					if ( xpp.getName().equals("image") ){
						wholeImageList.add(new Image(xpp.getAttributeValue(0), xpp.getAttributeValue(1), xpp.getAttributeValue(2)));
					}
				}
				xpp.next();
			}
			
			totalSize = wholeImageList.size();
			currentPage = page;

			start = (page - 1) * size; 
			end = (page*size);
			imageList.addAll(wholeImageList.subList(start, end));
			
		}catch(XmlPullParserException xppe){
			Log.i("error", "init()"+xppe);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}