package com.yeory.gv.util;

import java.util.ArrayList;

import android.content.Context;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.GridView;
import android.widget.ImageView;

import com.yeory.gv.model.Image;
import com.yeory.gv.util.ImageDownloader.Mode;
/**
 * =============================================================================
/            Ʈ :   GridView_Example
/            ȭ     :   ImageAdapter.java
/                   :   
/                   :   
/            Ư   :
/-----------------------------------------------------------------------------
/                                				                     
/-----------------------------------------------------------------------------
/           	(ۼ)                 		                  
/   ----------     	--------------------------       -------------------------
/   2010. 11. 10.      jYeory<jyeory@gmail.com>         		                         
/==============================================================================
 */
public class ImageAdapter extends BaseAdapter{
	private final ImageDownloader imageDownloader = ImageDownloader.getInstance();
	private final String LOG_TAG = "ImageAdapter";
	private Context mContext;
    private ImageView imageView;
    private ArrayList<Image> list;
    
    public ImageAdapter(Context c) {
        mContext = c;
    }
    
    public ImageAdapter(Context c, ArrayList<Image> list){
    	mContext = c;
    	this.setList(list);
    }
	
	
	@Override
	public int getCount() {
		Log.i(LOG_TAG, "called getCount()");
		return getList().size();
	}

	@Override
	public Object getItem(int position) {
		Log.i(LOG_TAG, "called getItem()");
		return null;
	}

	@Override
	public long getItemId(int position) {
		Log.i(LOG_TAG, "called getItemId()");
		return 0;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		Log.i(LOG_TAG, "called getView()");
		
		if (convertView == null) {  // if it's not recycled, initialize some attributes.
    		imageView = new ImageView(mContext);
    		imageView.setLayoutParams(new GridView.LayoutParams(150, 150));
    		imageView.setScaleType(ImageView.ScaleType.CENTER_CROP);
    		imageView.setPadding(4, 4, 4, 4);
        } else {
            imageView = (ImageView) convertView;
        }
		
		imageDownloader.setMode(Mode.CORRECT);
		imageDownloader.download(getList().get(position).getThumbNail(), imageView);
		return imageView;
	}

	public void setList(ArrayList<Image> list) {
		this.list = list;
	}

	public ArrayList<Image> getList() {
		return list;
	}
}